;Mapeditor

SetBuffer BackBuffer()


Include "grafikgui.bb"

;algemein setzen
Global 	map_x=20, frames=5
Global 	map_y=10, tiles$=""
		
Graphics (map_x+15)*32, map_y*32, 16, 2	
	
		
		If tiles$="" Then tiles$="Grafiken/tileset.png"


Dim map(map_x, map_y)

;tilemap laden
Global tileset=LoadAnimImage(tiles, 32, 32, 0, frames)

Global tile=0, mapx, mapy, mx, my, x, y

Repeat 
	Cls 
	 
	 ; darstellung
	 	
	If KeyDown(31) Or button ((map_x+2)*32, 0, "Karte speichern (S)", 200, 100, 100, True) Then savemap()
	If KeyDown(38) Or button ((map_x+2)*32, 50, "Karte laden (L)", 200, 100, 100, True ) Then loadmap()
	If button ((map_x+2)*32, 100, "Anzahl horizontale Tiles", 200, 100, 100, True ) Then 
		Cls 
		Flip(0)
		map_x=Input("Anzahl Tiles: ")
		Dim map(map_x, map_y)
		Graphics (10+map_x)*32, map_y*32, 16, 2
		tileset=LoadAnimImage(tiles, 32, 32, 0, frames)
	EndIf
	
	If button ((map_x+2)*32, 150, "Anzahl vertikale Tiles", 200, 100, 100, True ) Then 
		Cls 
		Flip(0)
		map_y=Input("Anzahl Tiles: ")
		Dim map(map_x, map_y)
		Graphics (10+map_x)*32, map_y*32, 16, 2
		tileset=LoadAnimImage(tiles, 32, 32, 0, frames)
	EndIf 
	
	If button((map_x+2)*32, 250, "neues Tileset laden", 200, 100, 100, False) Then 
		Cls 
		Flip(0)
		tiles$=Input("Gib das zu ladende Tileset an: ")+".png"
		frames=Input("Anzahl der Frames")
		tileset=LoadAnimImage(tiles, 32, 32, 0, frames)
	EndIf 
		
	drawmap()
	reset()

	 
	Flip(0)
Until KeyDown(1)
End  

;map darstellen und bearbeiten
Function drawmap()
	mx=MouseX()
	my=MouseY()
	
	
	;tiles setzen
	If MouseHit(2) Or button ((map_x+2)*32, 200, "Tile ndern (Rechte Maustaste)", 200, 100, 100, True) Then tile=tile+1
	If tile>frames-1 Then tile=0
	
	For y=1 To map_y
		For x=0 To map_x	
			DrawImage tileset, x*32, y*32, map(x,y)
		Next 
	Next
	
		;mausbeschrnkung
	If mx<(map_x+1)*32 Then
		Color 255,0,0
		Rect (mx-1, my-1, 34, 34,0)
		DrawImage tileset, mx, my, tile
		HidePointer()
	Else 
		ShowPointer()
	EndIf 
	
	
		

	;tiles zuweisen 
	If MouseDown(1) And mx<(map_x)*32 Then
		calk()
		map(mapx, mapy)=tile
	EndIf 
	

End Function 

Function calk()
	mapx=(mx+16)/32
	mapy=(my+16)/32
End Function 

Function savemap()
	Cls()
	FlushKeys()
	name$=Input("Gib einen Kartennamen ein: ") 
	karte$=WriteFile("maps/"+name$+".txt")
	
	For y=1 To map_y
		For x=0 To map_x
			WriteLine (karte$, tile)
			WriteInt  (karte$, map(x,y)) 
		Next 
	Next
	Cls 
	Text 100, 100, "Karte wurde erfolgreich gespeichert!"
	WaitKey()
	drawmap()
End Function 

Function loadmap()
	Cls 
	FlushKeys()
	name$=Input("Gib den Namen der zu ladenden Karte ein: ")
	karte$ = ReadFile("maps/"+name$+".txt")
	If karte$=0 Then RuntimeError("Karte konnte nicht gefunden werden!")
	For y = 1 To map_y
		For x = 0 To map_x
			tile = ReadLine(karte$)
			map(x, y) = ReadInt(karte$)
		Next
	Next
	CloseFile(karte$)
End Function 

Function reset()
	;Alles auf Starttile zurcksetzen
  If KeyDown(57) Then
	For y=1 To map_y
		For x=0 To map_x	
			map(x,y)=0
		Next 
	Next
 EndIf 
End Function