'Fr super Code
SuperStrict


AppTitle = "Blocks Must Die!"


Const EnemiesPerWave:Int = 30
Const EnemyHP:Int = 5
Const EnemyBonusHP:Int = 3
Const MoneyPerEnemy:Int = 5
Const Lifes:Int = 20
Const StartMoney:Int = 250

Global TowerCosts:Int[6]
TowerCosts[0] = 125
TowerCosts[1] = 150
TowerCosts[2] = 350
TowerCosts[3] = 100
TowerCosts[4] = 300
TowerCosts[5] = 200


#Map1
DefData 1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DefData 1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
DefData 1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1
DefData 1,1,1,1,1,1,1,1,1,3,3,1,1,1,1,1,1,1,1,1


#MultipleMissilesTower
DefData 100, 20				'Range, Bonus Range
DefData 3, 2				'Damage, Bonus Damage
DefData 1000, -100			'Cooldown, Bonus Cooldown

#PuncturingMissilesTower
DefData 100, 20				'Range, Bonus Range
DefData 2, 2				'Damage, Bonus Damage
DefData 1000, -100			'Cooldown, Bonus Cooldown

#LaserTower
DefData 120, 40				'Range, Bonus Range
DefData 1, 1				'Damage, Bonus Damage
DefData 100, -50			'Cooldown, Bonus Cooldown

#SlowingSphere
DefData 100, 20				'Range, Bonus Range
DefData 1, 0				'Speed-Verringerung, Bonus
DefData 0, 0				'La la la

#BuffSphere
DefData 140, 60				'Range, Bonus Range
DefData 0, 0				'Variiert je nach betroffenem Objekt
DefData 0, 0				'Doo doo doo

#ControllingSphere
DefData 100, 20				'Range, Bonus Range
DefData 0, 0				'Bla
DefData 0, 0				'Blubb



'Player-Type
Type TPlayer
	
	Field X:Float
	Field Y:Float
	
	Field XS:Float
	Field YS:Float
	
	Field Money:Int
	
	Field BaseDamage:Float
	Field Damage:Float
	Field AddDamage:Float
		
	Field LastShot:Int
	
	Field HP:Int
	
	Method Init()
		Self.X = 32
		Self.Y = 32
		
		Self.BaseDamage = 2
		Self.Damage = Self.BaseDamage
		Self.AddDamage = 2
		
		Self.LastShot = MilliSecs()
		
		Self.HP = Lifes
		
		Self.Money = StartMoney
	End Method
	
	Method Update()	
		If MD1 = True Then
			If SelectedTower = 0 Then
				If MilliSecs() > Self.LastShot + 200 Then
					Local Shot:TShot = New TShot
					Local Angle:Float = ATan2( MY - (Self.Y+16), MX - (Self.X+16) ) Mod 360
					Shot.Init( Self.X+16, Self.Y+16, Angle, Self.Damage )
					Map.ShotList.AddLast( Shot )
					Self.LastShot = MilliSecs()
				End If
			ElseIf SelectedPositionValid = True Then
				Self.Money :- TowerCosts[SelectedTower-1]
				Local Tower:TTower = New TTower
				Map.TowerList.AddLast( Tower )
				Tower.Init( SelectedPositionX, SelectedPositionY, SelectedTower )
				Map.Buildable[ SelectedPositionX, SelectedPositionY ] = 0
				SelectedTower = 0
				FlushMouse()
			End If
		End If
		
		Local KeyCode:Int
		Select ShownMenu
			Case 1			'Baumen
				For KeyCode = KEY_1 To KEY_6
					If KeyDown(KeyCode) Then
						If KeyDown(KEY_LSHIFT) Then
							ShownHelp = KeyCode - 48
						ElseIf Self.Money >= TowerCosts[ KeyCode - 48 - 1 ]
							SelectedTower = KeyCode - 48
							ShownMenu = 0
							Select SelectedTower
								Case 1; RestoreData MultipleMissilesTower
								Case 2; RestoreData PuncturingMissilesTower
								Case 3; RestoreData LaserTower
								
								Case 4; RestoreData SlowingSphere
								Case 5; RestoreData BuffSphere
								Case 6; RestoreData ControllingSphere
							End Select
							ReadData SelectedTowerRange
						End If
						Exit
					Else
						ShownHelp = 0
					End If
				Next
				
			Case 2			'Bonusmen
				'to do
		End Select
		
		If SelectedTower = 0 Then
			If MH2 = True Then
				If ShownMenu = 0 Or ShownMenu = 1 Then ShownMenu = 1 - ShownMenu
			End If
		Else
			SelectedPositionX = Min(MX/32, 19)
			SelectedPositionY = Min(MY/32, 18)
			SelectedPositionValid = False
			If Map.Tiles[ SelectedPositionX, SelectedPositionY ] = 0 Then SelectedPositionValid = True
			SelectedPositionValid = PointInSphere( SelectedPositionX*32+16, SelectedPositionY*32+16, Player.X+16, Player.Y+16, 150 )
			If Map.Buildable[ SelectedPositionX, SelectedPositionY ] = 0 Then SelectedPositionValid = False
			If SelectedTower < 4 And Map.Tiles[ SelectedPositionX, SelectedPositionY+1 ] <> 1 Then SelectedPositionValid = False
			If MH2 = True Then SelectedTower = 0
		End If
		
		If KeyDown(KEY_SPACE) Or KeyDown(KEY_W) And Self.CanJump() = True Then
			Self.YS = -12
		End If
		
		If KeyDown(KEY_D) Then
			Self.XS = Min( 4, Self.XS+.2 )
		ElseIf KeyDown(KEY_A) Then
			Self.XS = Max( -4, Self.XS-.2 )
		Else
			Self.XS:*.95
		End If
		
		If Self.Y + 32 + Self.YS > 640 Then
			Self.X = 32
			Self.Y = 32
		End If
		
		If Self.XS <> 0 Then
			Self.X :+ Self.XS
			If Self.CheckCollisions() = True Then
				While Self.CheckCollisions() = True
					Self.X :- (Self.XS/Abs(Self.XS))*.1
				Wend
				Self.XS = 0
			End If
		End If
		
		Self.Y :+ Self.YS
		If Self.CheckCollisions() = True Then
			If Self.YS <> 0 Then
				While Self.CheckCollisions() = True
					Self.Y :- (Self.YS/Abs(Self.YS))*.1
				Wend
				Self.YS = 0
			End If
		Else
			Self.YS :+ .5
		End If
		
		Self.Damage = Self.BaseDamage
		
	End Method
	
	Method Render()
		SetColor 255,0,255
		DrawRect Self.X, Self.Y, 32, 32
		SetColor 255,255,255
		
		SetColor 0,200,0
		Local w:Int = Float( Self.HP ) / Float( Lifes ) * 200
		DrawRect 320-w/2, 6, w, 20
		SetColor 255,255,255
		
		SetScale 3,3
		Local txt:String
		txt = Self.Money + "$"
		DrawText txt, 576 - TextWidth(txt)*3-3, -4
		SetScale 2,2
		txt = Self.HP + " / " + Lifes
		DrawText txt, 320 - TextWidth(txt)*2/2, 3
		SetScale 1,1
		
		If Map.WaveNR > 0 Then
			SetScale 3,3
			DrawText "Wave " + Map.WaveNR, 64, -4
			SetScale 1,1
		End If
		
		If SelectedTower > 0 Then
			DrawOval2( Player.X+16-150, Player.Y+16-150, 300, 300, 0 )
			If SelectedPositionValid Then
				SetColor 0,200,0
			Else
				SetColor 200,0,0
			End If
			SetAlpha 0.5
			DrawRect SelectedPositionX*32, SelectedPositionY*32, 32, 32
			SetColor 255,255,255
			SetAlpha 1
			Local X:Int = SelectedPositionX*32+16-SelectedTowerRange
			Local Y:Int = SelectedPositionY*32+16-SelectedTowerRange
			Local D:Int = SelectedTowerRange*2
			DrawOval2( X, Y, D, D, 0 )
		End If
	End Method
	
	Method CheckCollisions:Int(Tolerance:Int=0)
		Local C1:Int = ( Map.PointValue(Self.X+Tolerance, Self.Y+Tolerance) = 1 )
		Local C2:Int = ( Map.PointValue(Self.X+32-Tolerance, Self.Y+Tolerance) = 1 )
		Local C3:Int = ( Map.PointValue(Self.X+32-Tolerance, Self.Y+32-Tolerance) = 1 )
		Local C4:Int = ( Map.PointValue(Self.X+Tolerance, Self.Y+32-Tolerance) = 1 )
		If C1 Or C2 Or C3 Or C4 Then Return True
		Return False
	End Method
	
	Method CanJump:Int()
		Local Y:Int = Self.Y + 33
		
		Local C1:Int = ( Map.PointValue( Self.X + 0, Y ) = 1 )
		Local C2:Int = ( Map.PointValue( Self.X + 32, Y ) = 1 )
		
		If ( C1 Or C2 ) And Self.YS = 0 Then Return True
		Return False
	End Method
	
End Type


'Tower-Type
Type TTower
	
	Field X:Int
	Field Y:Int
	
	Field Typ:Int
	
	Field BaseRange:Int
	Field Range:Int
	Field AddRange:Int
	
	Field BaseDmg:Float
	Field Dmg:Float
	Field AddDmg:Float
	
	Field BaseCooldown:Int
	Field Cooldown:Int
	Field AddCooldown:Int
	
	Field LastShot:Int
	
	Field Target:TEnemy
	Field TargetAngle:Float
	
	Field Del:Int
	
	Method Init( X_:Int, Y_:Int, Typ_:Int )
		
		Self.X = X_
		Self.Y = Y_
		
		Self.Typ = Typ_
		
		Select Typ_
			Case 1; RestoreData MultipleMissilesTower
			Case 2; RestoreData PuncturingMissilesTower
			Case 3; RestoreData LaserTower
			
			Case 4; RestoreData SlowingSphere
			Case 5; RestoreData BuffSphere
			Case 6; RestoreData ControllingSphere
		End Select
		
		ReadData Self.BaseRange
		Self.Range = Self.BaseRange
		ReadData Self.AddRange
		
		ReadData Self.BaseDmg
		Self.Dmg = Self.BaseDmg
		ReadData Self.AddDmg
		
		ReadData Self.BaseCooldown
		Self.Cooldown = Self.BaseCooldown
		ReadData Self.AddCooldown
		
	End Method
	
	Method Update()
		
		Local Enemy:TEnemy
		If Self.Typ < 4 Or Self.Typ = 6 Then
			Local Weakest:TEnemy
			Local LowestHP:Int = 999999
			For Enemy = EachIn Map.EnemyList
				If PointInSphere( Enemy.X+16, Enemy.Y+16, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
					If Enemy.Hitpoints < LowestHP Then
						LowestHP = Enemy.Hitpoints
						Weakest = Enemy
					End If
				End If
			Next
			Self.Target = Weakest
			If Self.Target <> Null Then	Self.TargetAngle = ATan2( (Weakest.Y+16) - (Self.Y*32+16), (Weakest.X+16) - (Self.X*32+16) )
		End If
		
		Local Shot:TShot
		Local Tower:TTower
		Local i:Int
		Select Self.Typ
			Case 1				'MultipleMissilesTower
				If LastShot <= MilliSecs() - Self.Cooldown And Self.Target <> Null Then
					For i = -2 To 2 Step 2
						Shot = New TShot
						Map.ShotList.AddLast( Shot )
						Shot.Init( Self.X*32+16, Self.Y*32+16, Self.TargetAngle + i, Self.Dmg )
						Self.LastShot = MilliSecs()
					Next
				End If
			Case 2				'PuncturingMissilesTower
				If LastShot <= MilliSecs() - Self.Cooldown And Self.Target <> Null Then
					Shot = New TShot
					Map.ShotList.AddLast( Shot )
					Shot.Init( Self.X*32+16, Self.Y*32+16, Self.TargetAngle, Self.Dmg, 3 )
					Self.LastShot = MilliSecs()
				End If
			Case 3				'LaserTower
				If LastShot <= MilliSecs() - Self.Cooldown And Self.Target <> Null Then
					Self.Target.Hitpoints :- Self.Dmg
					Self.LastShot = MilliSecs()
				End If
			Case 4				'SlowingSphere
				For Enemy = EachIn Map.EnemyList
					If PointInSphere( Enemy.X+16, Enemy.Y+16, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
						Enemy.Speed = Enemy.BaseSpeed - Self.Dmg
					End If
				Next
			Case 5				'BuffSphere
				
				For Tower = EachIn Map.TowerList
					If PointInSphere( Tower.X*32+16, Tower.Y*32+16, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
						If ( Tower.X <> Self.X Or Tower.Y <> Self.Y ) Then
							Tower.Range = Tower.BaseRange + Tower.AddRange
							Tower.Dmg = Tower.BaseDmg + Tower.AddDmg
							Tower.Cooldown = Tower.BaseCooldown + Tower.AddCooldown
						End If
					End If
				Next
				If PointInSphere( Player.X+16, Player.Y+16, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
					Player.Damage = Player.BaseDamage + Player.AddDamage
				End If
			Case 6				'ControllingSphere
				For Shot = EachIn Map.ShotList
					If PointInSphere( Shot.X, Shot.Y, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
						If Self.Target <> Null Then
							Local Angle:Float = ATan2( (Self.Target.Y+16) - (Shot.Y), (Self.Target.X+16) - (Shot.X) )
							Shot.Init( Shot.X, Shot.Y, Angle, Shot.Damage, Shot.Hits )
						Rem
						Else
							For Tower = EachIn Map.TowerList
								If  And Tower.Typ = 6 Then
									If PointInSphere( Tower.X*32+16, Tower.Y*32+16, Self.X*32+16, Self.Y*32+16, Self.Range ) Then
										Local Angle:Float = ATan2( (Tower.Y*32+16) - (Shot.Y), (Tower.X*32+16) - (Shot.X) )
										Shot.Init( Shot.X, Shot.Y, Angle, Shot.Damage, Shot.Hits )
									End If
								End If
							Next
						End Rem
						End If
					EndIf
				Next
		End Select
		
		
		If KeyDown( KEY_DELETE ) = True And MX >= Self.X*32 And MY >= Self.Y*32 And MX <= Self.X*32+32 And MY <= Self.Y*32+32 Then
			Self.Del = True
			Player.Money :+ ( TowerCosts[ Self.Typ - 1 ] / 2 )
			Map.Buildable[ Self.X, Self.Y ] = 1
		End If
		
	End Method
	
	Method Render()
		
		Select Self.Typ
			Case 3				'LaserTower
				DrawOval Self.X*32, Self.Y*32, 32, 32
				If Self.Target <> Null Then
					SetColor 0,200,0
					DrawLine Self.X*32+16, Self.Y*32+16, Self.Target.X+15, Self.Target.Y+15
					SetColor 255,255,255
				End If
		End Select
		
		DrawOval Self.X*32, Self.Y*32, 32, 32
		SetColor 0,0,200
		Local txt:String = Self.Typ
		DrawText txt, Self.X*32+16 - TextWidth(txt)/2, Self.Y*32+16 - TextHeight(txt)/2
		SetColor 255,255,255
		
		If MD1 = True And MX >= Self.X*32 And MY >= Self.Y*32 And MX <= Self.X*32+32 And MY <= Self.Y*32+32 Then
			DrawOval2( Self.X*32+16-Self.Range, Self.Y*32+16-Self.Range, Self.Range * 2, Self.Range * 2, 0 )
		End If
		
	End Method
	
	Method Upgrade()
		Self.BaseRange :+ Self.AddRange
		Self.BaseDmg :+ Self.AddDmg
		Self.BaseCooldown :+ Self.AddCooldown
		Self.Range = Self.BaseRange
		Self.Dmg = Self.BaseDmg
		Self.Cooldown = Self.BaseCooldown
	End Method
	
End Type


'Schuss-Type
Type TShot
	
	Field X:Float
	Field Y:Float
	Field XS:Float
	Field YS:Float
	
	Field Del:Int
	
	Field Damage:Int
	
	Field Hits:Int
	Field LastDmgTime:Int
	
	Method Init( X_:Float, Y_:Float, Angle_:Float, Damage_:Int, Hits_:Int = 0 )
		Self.X = X_
		Self.Y = Y_
		Self.XS = Cos( Angle_ ) * 12
		Self.YS = Sin( Angle_ ) * 12
		Self.Damage = Damage_
		Self.Hits = Hits_
	End Method
	
	Method Update()
		Self.X :+ Self.XS
		Self.Y :+ Self.YS
		
		Local Enemy:TEnemy
		For Enemy = EachIn Map.EnemyList
			If PointInRect( Self.X, Self.Y, Enemy.X, Enemy.Y, 32, 32 ) And Self.LastDmgTime+400 < MilliSecs() Then
				Self.Hits :- 1
				If Self.Hits < 0 Then Self.Del = True
				Self.LastDmgTime = MilliSecs()
				Enemy.Hitpoints :- Self.Damage
			End If
		Next
		
		If Map.PointValue( Self.X, Self.Y ) <> 0 Then Self.Del = True
	End Method
	
	Method Render()
		DrawLine Self.X, Self.Y, Self.X-Self.XS, Self.Y-Self.YS
	End Method
	
End Type


'Gegner-Type
Type TEnemy
	
	Field X:Float
	Field Y:Float
	
	Field XS:Float
	Field YS:Float
	Field XDir:Int
	
	Field Hitpoints:Int
	
	Field Del:Int
	
	Field BaseSpeed:Float
	Field Speed:Float
	
	Method Init( X_:Int, Y_:Int, Direction:Float, HP_:Int)
		Self.BaseSpeed = 2
		Self.Speed = Self.BaseSpeed
		
		Self.X = X_
		Self.Y = Y_
		Self.XS = Direction*Self.Speed
		Self.XDir = Direction
		Self.Hitpoints = HP_
	End Method
	
	Method Update()
		
		Self.XS = Self.XDir*Self.Speed
		
		If Self.Hitpoints <= 0 Then
			Player.Money :+ MoneyPerEnemy
			Self.Del = True
		End If
		
		If Self.Y>640 Then
			Player.HP :- 1
			Self.Del = True
			
			If Player.HP <= 0 Then Loss = True
		End If
		
		If Self.XS <> 0 Then
			Self.X :+ Self.XS
			If Self.CheckCollisions() = True Then
				While Self.CheckCollisions() = True
					Self.X :- (Self.XS/Abs(Self.XS))*.1
				Wend
				Self.XDir :* -1
				Self.XS :* -1
			End If
		End If
		
		Self.Y :+ Self.YS
		If Self.CheckCollisions() = True Then
			If Self.YS <> 0 Then
				While Self.CheckCollisions() = True
					Self.Y :- (Self.YS/Abs(Self.YS))*.1
				Wend
				Self.YS = 0
			End If
		Else
			Self.YS :+ .5
		End If
		
		Self.Speed = Self.BaseSpeed
		
	End Method
	
	Method Render()
		SetColor 255,0,0
		DrawRect Self.X+1, Self.Y-1, 32, 32
		SetColor 255,255,255
	End Method
	
	Method CheckCollisions:Int(Tolerance:Int=1)
		Local C1:Int = ( Map.PointValue(Self.X+Tolerance, Self.Y+Tolerance) = 1 )
		Local C2:Int = ( Map.PointValue(Self.X+32-Tolerance, Self.Y+Tolerance) = 1 )
		Local C3:Int = ( Map.PointValue(Self.X+32-Tolerance, Self.Y+32-Tolerance) = 1 )
		Local C4:Int = ( Map.PointValue(Self.X+Tolerance, Self.Y+32-Tolerance) = 1 )
		If C1 Or C2 Or C3 Or C4 Then Return True
		Return False
	End Method
	
End Type


'Map-Type
Type TGameMap
	
	Field Tiles:Int[,]
	Field Buildable:Int[,]
	
	Field CountIncomingAreas:Int
	Field IncomingAreas:Int[,]
	
	Field EnemyList:TList
	Field ShotList:TList
	Field TowerList:TList
	
	Field LastSpawn:Int
	
	Field CountdownStart:Int
	Field WaveNR:Int
	Field SpawnedEnemies:Int
	
	Method Init()
		Self.Tiles = New Int[20,20]
		Self.Buildable = New Int[20,20]
		
		Self.CountIncomingAreas = 0
		Self.IncomingAreas = New Int[5,2]
		
		Self.EnemyList = CreateList()
		Self.ShotList = CreateList()
		Self.TowerList = CreateList()
		
		Self.LastSpawn = MilliSecs()
		
		Self.WaveNR = 0
		Self.SpawnedEnemies = 0
		Self.CountdownStart = 0
		
		RestoreData Map1
		Local X:Int
		Local Y:Int
		For Y = 0 To 19
			For X = 0 To 19
				ReadData Self.Tiles[X,Y]
				
				If Self.Tiles[X,Y] = 2 Then
					Self.IncomingAreas[Self.CountIncomingAreas,0] = X
					Self.IncomingAreas[Self.CountIncomingAreas,1] = Y
					Self.CountIncomingAreas :+ 1
				End If
				
				Self.Buildable[X,Y] = 1
			Next
		Next
	End Method
	
	Method Update()
		
		Local Enemy:TEnemy
		Local Shot:TShot
		Local Tower:TTower
		
		If KeyHit( KEY_ENTER ) = True And Self.CountdownStart = 0 Then
			Self.CountdownStart = MilliSecs()
			Self.SpawnedEnemies = 0
		ElseIf Self.SpawnedEnemies = EnemiesPerWave Then
			Self.CountdownStart = MilliSecs()
			Self.SpawnedEnemies = 0
		End If
		
		If Self.SpawnedEnemies < EnemiesPerWave And Self.CountdownStart + 10000 <= MilliSecs() And Self.CountdownStart > 0 Then
			If LastSpawn <= MilliSecs()-1000 Then
				If Self.SpawnedEnemies = 0 Then
					Self.WaveNR :+ 1
				End If
				Local I:Int
				Local X:Int
				Local Y:Int
				Local Direction:Int
				For I = 0 To Self.CountIncomingAreas - 1
					Enemy = New TEnemy
					X = Self.IncomingAreas[I,0]*32
					Y = Self.IncomingAreas[I,1]*32+32
					Direction = (X<10) - (X>9)
					Enemy.Init( X, Y, Direction, EnemyHP+EnemyBonusHP*(Self.WaveNR-1) )
					Self.EnemyList.AddLast( Enemy )
					Self.SpawnedEnemies :+ 1
				Next
				Self.LastSpawn = MilliSecs()
			End If
		End If
		
		
		
		For Enemy = EachIn Self.EnemyList
			Enemy.Update()
			If Enemy.Del = True Then
				ListRemove( Self.EnemyList, Enemy )
				Enemy = Null
			End If
		Next
		
		For Shot = EachIn Self.ShotList
			Shot.Update()
			If Shot.Del = True Then
				ListRemove( Self.ShotList, Shot )
				Shot = Null
			End If
		Next
		
		For Tower = EachIn Self.TowerList
			Tower.Update()
			If Tower.Del = True Then
				ListRemove( Self.TowerList, Tower )
				Tower = Null
			End If
		Next
	End Method
	
	Method Render()
		Local X:Int
		Local Y:Int
		For X = 0 To 19
			For Y = 0 To 19
				Select Self.Tiles[X,Y]
					Case 1
						DrawImage img_Block, X*32, Y*32
					Case 2
						DrawImage img_incarea, X*32, Y*32
					Case 3
						DrawImage img_exit, X*32, Y*32
				End Select
			Next
		Next
		
		Local Shot:TShot
		For Shot = EachIn Self.ShotList
			Shot.Render()
		Next
		
		Local Tower:TTower
		For Tower = EachIn Self.TowerList
			Tower.Render()
		Next
		
		Local Enemy:TEnemy
		For Enemy = EachIn Self.EnemyList
			Enemy.Render()
		Next
		
		If Self.CountdownStart + 10000 >= MilliSecs() And Self.CountdownStart > 0 Then
			SetScale 5,5
			Local txt:String = 10 - ( MilliSecs() - Self.CountdownStart ) / 1000
			DrawText txt, 320-(TextWidth(txt)*5/2), 20
			SetScale 1,1
		End If
			
		If Self.CountdownStart = 0
			Local txt:String = "Press Enter to start"
			DrawText txt, 320 - TextWidth(txt)/2, 40
		End If
	End Method
	
	Method PointValue:Int( X:Int, Y:Int )
		If X>-1 And X<640 And Y>-1 And Y<640 Then Return Self.Tiles[ X/32, Y/32 ]
		Return 0
	End Method
	
End Type




'Timer-Variable
Global Frametimer:TTimer

'Player
Global Player:TPlayer

'Maus
Global MX:Int
Global MY:Int
Global MD1:Int
Global MH2:Int

'Map
Global Map:TGameMap

'Background
Global img_Background:TImage

'Block
Global img_block:TImage

'Incoming Area
Global img_incarea:TImage
Global img_exit:TImage

'Global img_towers:TImage

'Ob und welches/welcher Men/Hilfetext gezeigt wird
Global ShownMenu:Int
Global ShownHelp:Int

'Zum Bau ausgewhlter Turm
Global SelectedTower:Int
Global SelectedPositionX:Int
Global SelectedPositionY:Int
Global SelectedPositionValid:Int
Global SelectedTowerRange:Int

Global Loss:Int
Global lossscale:Float = 7
Global lossscalev:Float = .3


'Programm initialisieren
InitProgram()
InitGame()


'Hauptschleife
While Not( KeyHit( KEY_ESCAPE ) Or AppTerminate() )		'Beenden falls Escape oder Schlieen gedrckt wird
	
	If Loss = False Then
		MX = MouseX()
		MY = MouseY()
		MD1 = MouseDown( MOUSE_LEFT )
		MH2 = MouseHit( MOUSE_RIGHT )
		
		Map.Update()
		Player.Update()
		
		DrawImage img_Background, 0, 0
		Map.Render()
		Player.Render()
		
		Select ShownMenu
			Case 1			'Baumen
				ShowBuildingMenu()
				
			Case 2			'Bonusmen
				ShowBonusMenu()
		End Select
	Else
		SetColor 255,0,0
		DrawRect 0,0,640,640
		SetColor 255,255,255
		lossscale :+ lossscalev
		If lossscale <= 5 Or lossscale >= 10 Then lossscalev :* -1
		SetScale lossscale, 25-lossscale
		Local txt:String = "YOU LOST"
		DrawText txt, 320-TextWidth(txt)*lossscale/2, 320-TextHeight(txt)*(20-lossscale)/2
		SetScale 2,2
		txt = "Last wave cleared: " + (Map.WaveNR - 1)
		DrawText txt, 320-TextWidth(txt), 500
		SetScale 1,1
	End If
	
	WaitTimer( Frametimer )			'60 FPS einhalten per Frametimer
	Flip( 0 )						'Buffer flippen
	Cls( )							'Backbuffer leeren
	
Wend



'Programm beenden
End



'Programm initialisieren
Function InitProgram()
	
	'Frametimer fr 60 FPS erstellen
	Frametimer = CreateTimer( 60 )
	
	'Grafikfenster
	Graphics 640, 640, 0
	
	'Alphablende setzen
	SetBlend( ALPHABLEND )
	
	'Background
	img_Background = CreateImage( 640, 640 )
	Local y:Int
	For y = 0 To 19
		SetColor 0,0,7*y
		DrawRect 0, y*32, 640, 32
	Next
	GrabImage( img_Background, 0, 0 )
	Cls
	
	'Block
	img_Block = CreateImage( 32, 32 )
	For y = 0 To 15
		SetAlpha( Rnd( .9, 1 ) )
		SetColor 140-y*2.5,140-y*2.5,140-y*2.5
		DrawLine 0,y,32,y
		DrawLine 0,y+16,32,y+16
	Next
	Local x:Int
	Local x2:Int
	For x = 0 To 2
		For x2 = -1 To 1
			SetColor 30+Abs(x2)*60, 30+Abs(x2)*60, 30+Abs(x2)*60
			DrawLine x*16+x2, 16*(x Mod 2), x*16+x2, 15+16*(x Mod 2)
		Next
	Next
	GrabImage img_Block, 0, 0
	Cls
	
	'incoming Area
	img_incarea = CreateImage(32, 32)
	Local fy:Float
	Local i:Int
	For fy = 0 To 31
		SetAlpha( Rnd( .9, 1 ) )
		SetColor 0,180-fy*6,0
		DrawLine 0,fy,31,fy
		SetColor 0,255,0
	Next
	GrabImage img_incarea, 0, 0
	Cls
	
	'exit
	img_exit = CreateImage( 32, 32 )
	SetColor 0,0,133
	DrawRect 0, 0, 32, 32
	SetColor 180, 0, 0
	For fy = 0 To 31
		SetAlpha( Rnd( .9, 1 ) - 1.0/38.0*fy )
		DrawLine 0,31-fy,31,31-fy
	Next
	GrabImage img_exit, 0, 0
	Cls
	
	'img_towers = LoadAnimImage( "towers.png", 32, 32, 0, 1 )
	
	SetAlpha 1
	SetColor 255, 255, 255
	
	
	
End Function


'Spiel initialisieren
Function InitGame()

	'Map initialisieren
	Map = New TGameMap
	Map.Init()
	
	'Spieler initialisieren
	Player = New TPlayer
	Player.Init()
	
End Function


Function ShowBuildingMenu()
	
	SetAlpha .5
	SetColor 40, 40, 140
	
	DrawRect 20, 20, 500, 190
	
	SetAlpha 1
	SetColor 255, 255, 255
	
	DrawText "(1) Multiple-Missiles-Tower", 35, 35
	DrawText TowerCosts[0] + "$", 470, 35
	
	DrawText "(2) Puncturing-Missiles-Tower", 35, 55
	DrawText TowerCosts[1] + "$", 470, 55
	
	DrawText "(3) Laser-Tower", 35, 75
	DrawText TowerCosts[2] + "$", 470, 75
	
	DrawText "(4) Slowing-Sphere", 35, 110
	DrawText TowerCosts[3] + "$", 470, 110
	
	DrawText "(5) Buff-Sphere", 35, 130
	DrawText TowerCosts[4] + "$", 470, 130
	
	DrawText "(6) Controlling-Sphere", 35, 150
	DrawText TowerCosts[5] + "$", 470, 150
	
	Select ShownHelp
		Case 0; DrawText "Press Shift + Number to display help text", 35, 185
		Case 1; DrawText "Fires multiple missiles", 35, 185
		Case 2; DrawText "Fires missiles which go through multiple enemies", 35, 185
		Case 3; DrawText "Damages enemies with a constant laser ray", 35, 185
		Case 4; DrawText "Enemies are slower while being in this tower's range", 35, 185
		Case 5; DrawText "Strength of towers and player, while in range, is increased", 35, 185
		Case 6; DrawText "Projectiles in range are being moved towards enemies", 35, 185
	End Select
	
End Function


Function ShowBonusMenu()

End Function


Function PointInRect:Int( PX:Int, PY:Int, RX:Int, RY:Int, RW:Int, RH:Int )
	Return ( PX >= RX And PX <= RX + RW And PY >= RY And PY <= RY + RH )
End Function

Function PointInSphere:Int( PX:Int, PY:Int, SX:Int, SY:Int, SR:Int )
	Local dist:Int = Sqr( (PX-SX)^2 + (PY-SY)^2 )
	Return( dist <= SR )
End Function

Function DrawOval2( x:Float, y:Float, w:Float, h:Float, Filled:Int )	'Funktion von Midimaster
	Local i:Int, X1:Float, Y1:Float, X2:Float, Y2:Float
	If Filled=0 Then
		w=w/2
		h=h/2
		y=y+h
		x=x+w
		X2=(Sin(0)*w+0.5)
		Y2=(Cos(0)*h+0.5)
		Repeat
			X1=X2
			Y1=Y2
			While (Int(X1)=Int(Sin(i+1)*w+0.5)) Or (Int(Y1)=Int(Cos(i+1)*h+0.5))
				i=i+1
				If i>360 Then Exit
			Wend
			X2=(Sin(i+2)*w+0.5)
			Y2=(Cos(i+2)*h+0.5)
			i=i+2
			DrawLine x+X1,y+Y1,x+X2,y+Y2
		Until i>360
	Else
		DrawOval x, y, w, h
	EndIf	 
End Function


