;*******Grafikteil der Hobbitengine*******

;folgende Befehle sind in Version 1.0 vorhanden:

;button(x, y, schrift$, red, green, blue)--> zum erstellen von Knpfen

;Animateobject(image, animationstime, x, y, firstframe, lastframe)--> Erstellt eine Animation an einer bestimmten Position mit vorgegebener Zeit zwischen den Frames

;window(x, y, hoehe, breite, name)--> erstellt ein Fenster 



Global fontbig=LoadFont("DisplayOTF.otf", 30)
SetFont fontbig
Global fontsmall=LoadFont("Arial", 12)

Function button(x, y, schrift$, red, green, blue, schatten)
	
	If schatten=True Then 
		For i=20 To 1 Step -2
			Color Abs(red-i*5), Abs(green-i*5), Abs(blue-i*5); Farbe wenn nicht berhert
			Rect(x+(i*0.5), y+(i*0.5), StringWidth(schrift)+20, StringHeight(schrift)+20, 1)  ;malt den hintergrund
		Next 
		Color red+100, blue+100, green+100
		
		Text x+5, y+5, schrift
		
		If MouseX()> x And MouseX()<x+StringWidth(schrift)+20 And MouseY()> y And MouseY()<y+StringHeight(schrift)+20 Then 
			
			For i=20 To 1 Step -2
				Color Abs(red-30-(5*i)), Abs(green-30-(5*i)), Abs(blue-30-(5*i))
				Rect(x+(i*0.5), y+(i*0.5), StringWidth(schrift)+20, StringHeight(schrift)+20, 1)  ;malt den hintergrund
			Next 
			Color red+100, blue+100, green+100
			Text x+5, y+5, schrift
			If MouseDown(1) Then Return True ; Taste gedrckt --> nchste Aktion			
		EndIf 

	Else 

		Color red, green, blue; Farbe wenn nicht berhert
		Rect(x, y, StringWidth(schrift)+20, StringHeight(schrift)+20, 1)  ;malt den hintergrund
		Color green, red , blue
		Text x+5, y+5, schrift
		
		If MouseX()> x And MouseX()<x+StringWidth(schrift)+20 And MouseY()> y And MouseY()<y+StringHeight(schrift)+20 Then 
			Color red-30, green-30, blue-30
			Rect(x, y, StringWidth(schrift)+20, StringHeight(schrift)+20, 1)  ;malt den hintergrund bei Berhrung
			Color red+100, blue+100, green+100
			Text x+5, y+5, schrift
			If MouseDown(1) Then Return True ; Taste gedrckt --> nchste Aktion			
		EndIf 
	EndIf
	
		
	 		
End Function

Global animtimer, frame

Function Animateobject(image,  x, y, animationstime, firstframe, lastframe)
	;erstelle einen Animationstimer
	 
	
	If MilliSecs()>animtimer Then 
  		 animtimer=MilliSecs()+animationstime 
  		 frame=frame+1
		 If frame<firstframe Then frame=firstframe
  		 If frame>lastframe Then frame=firstframe
  	 EndIf

	; Bild in abhngigkeit von Frame malen
	DrawImage image, x, y, frame
	
End Function 

Global klick

Function checkbox(hoehe, weite, x, y)
		
		 md=MouseHit(1)
		 Color 0, 255, 0	
		 Rect(x, y, hoehe, weite, 1)
		 If MouseX()> x And MouseX()<x+weite And MouseY()> y And MouseY()<y+hoehe Then 
			If md Then klick=1-klick
		 EndIf 
	
		If klick=1 Then 
			Rect(x, y, hoehe, weite, 1)
			Color 0, 0, 255
			Rect(x+5, y+5, hoehe-10, weite-10, 1)
			Return True 
		 
		Else 
			Return False 
		EndIf 		
End Function 

Function window(x, y, breite, hoehe, name$="")
	;Umrandung
	Color 130, 130, 130
		Rect x, y, breite, hoehe, True  
	Color 255, 0, 0
		Rect x, y, breite, hoehe, False 
	If name<>"" Then 
		Color 130, 130, 130
		Rect x+5, y+5, breite-10, StringHeight(name$), True 
		Color 0, 255, 0
		Rect x+5, y+5, breite-10, StringHeight(name$), False
		;name/fenstertext
		If StringWidth(name$)> breite-10 Then name$=Mid(name$, 1, 15)+"..."
		Text x+breite/2-StringWidth(name$)/2, y+5, name$
	EndIf 
 
End Function 





	


	