;spieler

;Bewegungskonstanten

Type spieler
	Field x,y
	Field image
	Field animtimer
	Field speed
	Field geld
	Field Leben
End Type

;Figur erstellen
Global s.spieler=New spieler
s\x=180
s\y=200
s\Geld=10000
s\image=LoadAnimImage("Grafiken/spieler.png", 32, 32, 0, 8)
MaskImage s\image, 255, 0, 255
s\animtimer=200
s\speed=10
s\Leben=10


Global 	map_x=19
Global 	map_y=15
Dim map(map_x, map_y)


;Spielerfunktion mit Bewegung und Mapwechsel
Function spieler()
	;Bewegungsanimationen
	;oben
	
	
	If KeyDown(17); And map(s\x/32, s\y/32-1)<>0 And map(s\x/32, s\y/32-1)<>2 Then
		Animateobject(s\image,  s\x, s\y, s\animtimer, 0, 1)
		s\y=s\y-s\speed
		If s\y<32 Then s\y=32 
		 
	;unten
	ElseIf  KeyDown(31) ;And  map(s\x/32, s\y/32+1)<>0 And map(s\x/32, s\y/32+1)<>2  
		Animateobject(s\image,  s\x, s\y, s\animtimer, 2, 3)
		s\y=s\y+s\speed
		If s\y>468 Then s\y=468
			
	;links
 	ElseIf  KeyDown(30) ;And  map(s\x/32-1, s\y/32)<>0 And map(s\x/32-1, s\y/32)<>2
		Animateobject(s\image,  s\x, s\y, s\animtimer, 4, 5)
		s\x=s\x-s\speed
		If s\x<-32 Then
			s\x=620
			nextmap(links) 
		EndIf 
	;rechts
	ElseIf   KeyDown(32); And  map(s\x/32+1, s\y/32)<>0 And map(s\x/32+1, s\y/32)<>2
		Animateobject(s\image,  s\x, s\y, s\animtimer, 6, 7)
		s\x=s\x+s\speed
		If s\x>620 Then
			If mapcount=5 Then store()
			s\x=-32
			nextmap(rechts)
		EndIf
	Else 
		 Animateobject(s\image,  s\x, s\y, s\animtimer, 7, 7)
	EndIf 
End Function

;Gegner

;Gegnerkonstanten
Const Soldat=1
Const Tank=2
Const Boss=3





Type enemy
	Field x, y
	Field typ
	Field image
	Field leben
	Field speed
	Field wert
	Field animtimer
	Field frame
	Field reach
	Field entfernung
End Type

Type bossschuss
	Field x, y, bx, by
	Field image 
	Field speed
	Field schaden
	Field schusswinkel
	Field entfernung
End Type



Function createenemy(Typ, x, y)
	;Gegnerwerte nach Typ zuweisen
	Select typ
		Case Soldat
			e.enemy=New enemy
			e\x=x
			e\y=y
			e\image=soldatimage
			e\leben=5
			e\speed=Rand(2,4)
			e\wert=100
			e\entfernung=Rand(100, 300)
		Case Tank		
			e.enemy=New enemy
			e\x=x
			e\y=y
			e\image=tankimage			
			e\leben=10
			e\speed=Rand(2,4)
			e\wert=150
			e\entfernung=Rand(100, 300)
		Case Boss
			e.enemy=New enemy
			e\x=x
			e\y=y
			e\image=Bossimage
			e\leben=30
			e\speed=3
			e\wert=0
			e\entfernung=0
	End Select 
	
End Function 



Function drawenemy()

	For e.enemy=Each enemy
		
		If MilliSecs()>e\animtimer Then 
  		 e\animtimer=MilliSecs()+200 
		 e\frame=e\frame+1
		 If e\frame<0 Then e\frame=1
  		 If e\frame>1 Then e\frame=0
  	 	EndIf

	
	;Bewegung der Gegner
	Select e\image
		Case tankimage
		If e\x<620 And e\x>0 Then 
			If e\reach<e\entfernung  Then 
				e\x=e\x+e\speed
				e\reach=e\reach+e\speed 
			ElseIf e\reach=>e\entfernung And e\reach<2*e\entfernung
				e\x=e\x-e\speed
				e\reach=e\reach+e\speed
			ElseIf e\reach=>2*e\entfernung
				e\reach=0
			EndIf 
		EndIf
		
		Case soldatimage
		If e\y>=0 And e\y=<480 Then 
			If e\reach<e\entfernung Then 
				e\y=e\y+e\speed
				e\reach=e\reach+e\speed 
			ElseIf e\reach=>e\entfernung And e\reach<2*e\entfernung
				e\y=e\y-e\speed
				e\reach=e\reach+e\speed
			ElseIf e\reach=>2*e\entfernung
				e\reach=0
			EndIf 
		ElseIf e\y<=32 
			e\y=480
		Else 
			e\y=32
		EndIf 
		Case bossimage
			;winkel
			
			e\entfernung=e\entfernung+e\speed
			e\x=Cos(e\entfernung)*50+350
			e\y=-Sin(e\entfernung)*50+200
		; Schsse die der Endgegner abgibt
		If bosstimer<MilliSecs() Then 
		    bosstimer=MilliSecs()+1000
			b.bossschuss=New bossschuss
			b\bx=e\x+32
			b\by=e\y+32
			b\image=schussimage
			b\schaden=2
			b\schusswinkel=ATan2(e\x-(s\x+16), e\y-(s\y+16))+85
			b\speed=20
			
		EndIf 	
		 
		For b.bossschuss=Each bossschuss
			;Berechnung der Schussposition
			b\x=(Cos(b\schusswinkel)*b\entfernung)+b\bx
			b\y=-(Sin(b\schusswinkel)*b\entfernung)+b\by
			b\entfernung=b\entfernung+b\speed
			;Kugeln malen
			DrawImage b\image, b\x, b\y
			
			If  Not(First bossschuss=Null)
	  		 	If ImagesCollide(b\image, b\x, b\y, 0, s\image, s\x, s\y, 0)  Then
					s\leben=s\leben-b\schaden
					Delete b.bossschuss 	
				EndIf 
		   
				;If b\x>640 Or b\x<-32 Or b\y>480 Or b\y<32 Then Delete b.bossschuss
		    EndIf
		Next
	End Select


;	Schusskollision
		 
	If  Not(First schuss=Null)
	   For g.schuss=Each schuss
		If ImagesCollide(g\image, g\x, g\y, 0, e\image, e\x, e\y, 0)  Then
			e\leben=e\leben-g\schaden
			Delete g.schuss
			;Wenn die Leben 0 sind, dann sterben und Geld an Spieler geben
			If e\leben<=0 Then s\geld=s\geld+e\Wert:Delete e.enemy:Exit 	
		EndIf 
	   Next
	EndIf 
	
	If Not(e.enemy=Null)
		DrawImage e\image, e\x, e\y, e\frame
	
		If ImagesCollide(e\image, e\x, e\y, 1, s\image, s\x, s\y, 0) And super=False Then
			s\leben=s\leben-1
			super=True
			ctimer=MilliSecs()+1000 
		EndIf 
	
	ElseIf e.enemy=Null And mapcount=6 
		 sequenz("Ende")
	EndIf
	 
	If 	MilliSecs()>ctimer Then super=False
	Next
End Function 


Function Deleteenemy()	
	For e.enemy=Each enemy
		Delete e.enemy
	Next
End Function 


Function loadenemy()
	
	Select mapcount 
		Case 1			
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Soldat,  Rnd(200,500), Rnd(50, 250))
			createenemy(soldat,  Rnd(200,500), Rnd(50, 250))
		
		Case 2
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Tank,  Rnd(200,200), Rnd(50, 250))
			createenemy(tank,  Rnd(200,200), Rnd(50, 250))
		Case 3
			createenemy(tank, Rnd(200,200), Rnd(50, 250))
			createenemy(tank, Rnd(200,200), Rnd(50, 250))
			createenemy(Tank,  Rnd(200,200), Rnd(50, 250))
			createenemy(tank,  Rnd(200,200), Rnd(50, 250))
		Case 4
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Tank,  Rnd(200,200), Rnd(50, 250))
			createenemy(tank,  Rnd(200,200), Rnd(50, 250))
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Soldat, Rnd(200,500), Rnd(50, 250))
			createenemy(Tank,  Rnd(200,200), Rnd(50, 250))
			createenemy(tank,  Rnd(200,200), Rnd(50, 250))
		Case 5
			createenemy(Tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(Tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(Tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(tank,  Rnd(200,400), Rnd(50, 450))			
			createenemy(Tank,  Rnd(200,400), Rnd(50, 450))
			createenemy(tank,  Rnd(200,400), Rnd(50, 450))	
		Case 6
			createenemy(Boss,  400, 200)
	End Select
End Function 
	
			
			
			
			
			
			
			
			
			
			
			